package  
{
	import com.bit101.components.PushButton;
	import com.buraks.utils.fastmem;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.media.Camera;
	import flash.media.Video;
	import flash.net.FileReference;
	import flash.utils.ByteArray;
	import com.flashdynamix.utils.SWFProfiler;
	import flash.utils.setTimeout;
	
	/**
	 * ...
	 * @author Jaaq
	 */
	public class Source extends MovieClip 
	{
		
		private var video:Video;
		private var canvas:Bitmap;
		private var canvasBitmapData:BitmapData;
		private var yy:int = 0;
		private var _w:int = 320;
		private var _h:int = 240;
		private var cam:Camera;
		private var byteArray:ByteArray;
		private var numBytes:int;
		private var b:uint;
		private var g:uint;
		private var r:uint;
		private var a:uint;
		private var countr:int;
		private var button:PushButton;
		private var count:int;
		private var photoTaken:Boolean = false;
		private var effect:int = 0;
		private var next:PushButton;
		
		public function Source() 
		{
			SWFProfiler.init(this.stage, this);
			setupCam();
			setupComps();
			addEventListener("enterFrame", frameHandler);
		}
		
		private function frameHandler(e:Event):void 
		{
			countr++;
			canvasBitmapData.draw(video);
			byteArray = canvasBitmapData.getPixels(new Rectangle(0, 0, _w, _h));
			doFastMem();
		}
		
		private function doFastMem():void 
		{
			byteArray.position = 0; 					
			fastmem.fastSelectMem(byteArray); 
			
			for (var i:int = 0; i < numBytes; i += 4)											
			{	
				if(effect == 0) fastmem.fastSetI32(fastmem.fastGetI32((i * 2) % (numBytes/2)), i); 
				if(effect == 1) fastmem.fastSetI32(fastmem.fastGetI32(i  % (numBytes/2)), i); 
				if(effect == 2) fastmem.fastSetI32(fastmem.fastGetI32((numBytes - i)%numBytes), i); 
				if(effect == 3) fastmem.fastSetI32(fastmem.fastGetI32(i), i + (2)); 
				if(effect == 4) fastmem.fastSetI32(fastmem.fastGetI32(152320 + (i % 1280)), (152320 + (i % 25600)) % numBytes); 
				if(effect == 5) fastmem.fastSetI32(fastmem.fastGetI32(i) | fastmem.fastGetI32((countr * i) % numBytes), i);
				if(effect == 6) fastmem.fastSetI32(fastmem.fastGetI32((i * 2) % numBytes), i); 
				if(effect == 7) fastmem.fastSetI32(fastmem.fastGetI32((152320 + (i % 25600)) % numBytes), 177920 + (i % (numBytes-177920) )); 
				if(effect == 8) fastmem.fastSetI32(fastmem.fastGetI32(i) | fastmem.fastGetI32((i + 4) % numBytes), i); 	
			}
		
			fastmem.fastDeselectMem(); 					
			canvasBitmapData.setPixels(new Rectangle(0, 0, _w, _h), byteArray);					
		}
		
		private function setupCam():void 
		{
			numBytes = _w * _h * 4;
			canvasBitmapData = new BitmapData(_w,_h, true);
			cam = Camera.getCamera();
			cam.setMode(320,240,30);
			cam.setQuality(0, 100);

			video = new Video(_w,_h);
			video.attachCamera(cam);
			
			canvas = new Bitmap(canvasBitmapData);
			canvas.width = _w;
			canvas.height = _h;
			canvas.scaleX = canvas.scaleY = 2;
			addChild(canvas);
	
		}
		
		private function setupComps():void {
			new PushButton(this.stage, 500,20, "Next Effect",doNext);
		}
		
		private function doNext(e:Event):void 
		{
			effect = ++effect % 9;
		}
		
	}

}